UNIT FiltBuf; {Copyright 1992 Paul Milenkovic ALL RIGHTS RESERVED}

INTERFACE USES DSPTypes;


CONST
    wrk_max = 4096;
    wrk_mrk = 2048; {Must be at least DSPTypes.mbuf+DSPTypes.mcoef}

TYPE
    wrk_bufT = ARRAY [1 .. wrk_max] OF INTEGER;


PROCEDURE LoadBufferValuesDif(

    VAR wrk_buf: wrk_bufT; VAR sig: sig_buffer;
    pos, nbuf: INTEGER; scale, alpha: DOUBLE
);


FUNCTION RMSCF(

    VAR wrk_buf: wrk_bufT; pos, nbuf: INTEGER; ms: SINGLE

): SINGLE;


FUNCTION RMSdB(

    VAR wrk_buf: wrk_bufT; pos, nbuf: INTEGER; scale: SINGLE

): SINGLE;


IMPLEMENTATION

PROCEDURE LoadBufferValuesDif(

    VAR wrk_buf: wrk_bufT; VAR sig: sig_buffer;
    pos, nbuf: INTEGER; scale, alpha: DOUBLE
);

    VAR i, p: INTEGER;

BEGIN
    pos := pos + mmcoef;
    p   := mmcoef;
    WHILE pos < 2 DO BEGIN
        sig[p] := 0;
        Inc(p);
        Inc(pos);
    END;
    IF alpha = 0 THEN
        FOR i := p TO Pred(nbuf) DO BEGIN
            sig[i] := scale*wrk_buf[pos];
            Inc(pos);
        END
    ELSE
    IF alpha = 1 THEN
        FOR i := p TO Pred(nbuf) DO BEGIN
            sig[i] := scale*(wrk_buf[pos] - wrk_buf[Pred(pos)]);
            Inc(pos);
        END
    ELSE
        FOR i := p TO Pred(nbuf) DO BEGIN
            sig[i] := scale*(wrk_buf[pos] - alpha*wrk_buf[Pred(pos)]);
            Inc(pos);
        END;
END;


FUNCTION RMSCF(

    VAR wrk_buf: wrk_bufT; pos, nbuf: INTEGER; ms: SINGLE

): SINGLE;

    VAR p, nzcross: INTEGER;

BEGIN
    IF pos < 2 THEN BEGIN
        nbuf := nbuf + pos - 2;
        pos  := 2;
    END;
    nzcross := 0;
    FOR p := 0 TO Pred(nbuf) DO BEGIN
        IF (wrk_buf[pos] < 0) XOR (wrk_buf[Pred(pos)] < 0) THEN Inc(nzcross);
        Inc(pos);
    END;
    IF nbuf > 0 THEN
        RMSCF := (0.5*nzcross)/(ms*nbuf)
    ELSE
        RMSCF := 1/ms;
END;


FUNCTION RMSdB(

    VAR wrk_buf: wrk_bufT; pos, nbuf: INTEGER; scale: SINGLE

): SINGLE;

    VAR p: INTEGER;
        samp: SINGLE;

    FUNCTION Square(a: INTEGER): LONGINT;

    INLINE(
        $58/        {POP  AX}
        $89/$C2/    {MOV  DX,AX}
        $F7/$EA     {IMUL DX}
    );

BEGIN
    IF pos < 2 THEN BEGIN
        nbuf := nbuf + pos - 2;
        pos  := 2;
    END;

    samp := 0;
    FOR p := 0 TO Pred(nbuf) DO BEGIN
        samp := samp + Square(wrk_buf[pos]);
        Inc(pos);
    END;

    IF samp > 0 THEN
        RMSdB :=  10.0*ln(scale*scale*samp/nbuf)/ln(10.0)
    ELSE
        RMSdB := -99.99;
END;

END.
